<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: sparse_vector_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">sparse_vector_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2009  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_SVm_SPARSE_VECTOR_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_SVm_SPARSE_VECTOR_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;cmath&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../serialize.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;../graph_utils/sample_pair_abstract.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;../graph_utils/ordered_sample_pair_abstract.h&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">struct </span>has_unsigned_keys</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    {</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">bool</span> value = is_unsigned_type&lt;typename T::value_type::first_type&gt;::value;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    };</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type distance_squared (</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="keyword">const</span> U&amp; b</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    );</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U, <span class="keyword">typename</span> V, <span class="keyword">typename</span> W&gt;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type distance_squared (</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keyword">const</span> V&amp; a_scale,</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keyword">const</span> W&amp; b_scale,</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keyword">const</span> U&amp; b</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    );</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type distance (</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="keyword">const</span> U&amp; b</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    );</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U, <span class="keyword">typename</span> V, <span class="keyword">typename</span> W&gt;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type distance (</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keyword">const</span> V&amp; a_scale,</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keyword">const</span> W&amp; b_scale,</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keyword">const</span> U&amp; b</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    );</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="keywordtype">void</span> assign (</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        T&amp; dest,</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keyword">const</span> U&amp; src</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    );</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160; </div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type dot (</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        <span class="keyword">const</span> T&amp; b</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    );</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T1, <span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3, <span class="keyword">typename</span> T4, <span class="keyword">typename</span> T5, <span class="keyword">typename</span> T6&gt;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    T4 dot (</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keyword">const</span> std::vector&lt;T1,T2&gt;&amp; a,</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keyword">const</span> std::map&lt;T3,T4,T5,T6&gt;&amp; b</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    );</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T1, <span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3, <span class="keyword">typename</span> T4, <span class="keyword">typename</span> T5, <span class="keyword">typename</span> T6&gt;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    T4 dot (</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keyword">const</span> std::map&lt;T3,T4,T5,T6&gt;&amp; a,</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keyword">const</span> std::vector&lt;T1,T2&gt;&amp; b</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    );</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160; </div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type dot (</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; b</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    );</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160; </div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type dot (</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; a,</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keyword">const</span> T&amp; b</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    );</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160; </div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type length_squared (</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="keyword">const</span> T&amp; a</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    );</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type length (</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keyword">const</span> T&amp; a</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    );</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160; </div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <span class="keywordtype">void</span> scale_by (</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        T&amp; a,</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <span class="keyword">const</span> U&amp; value</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    );</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160; </div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    T add (</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        <span class="keyword">const</span> T&amp; b</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    );</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160; </div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    T subtract (</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        <span class="keyword">const</span> T&amp; a,</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keyword">const</span> T&amp; b</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    );</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160; </div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_index_plus_one (</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        <span class="keyword">const</span> T&amp; samples</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    ); </div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160; </div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keywordtype">long</span> NR, <span class="keywordtype">long</span> NC, <span class="keyword">typename</span> MM, <span class="keyword">typename</span> L, <span class="keyword">typename</span> SRC, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> add_to (</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        matrix&lt;T,NR,NC,MM,L&gt;&amp; dest,</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        <span class="keyword">const</span> SRC&amp; src,</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="keyword">const</span> U&amp; C = 1</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    );</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160; </div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keywordtype">long</span> NR, <span class="keywordtype">long</span> NC, <span class="keyword">typename</span> MM, <span class="keyword">typename</span> L, <span class="keyword">typename</span> SRC, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> subtract_from (</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;        matrix&lt;T,NR,NC,MM,L&gt;&amp; dest,</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        <span class="keyword">const</span> SRC&amp; src,</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;        <span class="keyword">const</span> U&amp; C = 1</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    );</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160; </div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type min (</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;        <span class="keyword">const</span> T&amp; vect</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    );</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160; </div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    <span class="keyword">typename</span> T::value_type::second_type max (</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        <span class="keyword">const</span> T&amp; vect</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    );</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160; </div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        <span class="keyword">typename</span> sample_type</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        &gt;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    matrix&lt;typename sample_type::value_type::second_type,0,1&gt; sparse_to_dense (</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;        <span class="keyword">const</span> sample_type&amp; vect</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    );</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160; </div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        <span class="keyword">typename</span> sample_type</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;        &gt;</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;    matrix&lt;typename sample_type::value_type::second_type,0,1&gt; sparse_to_dense (</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;        <span class="keyword">const</span> sample_type&amp; vect,</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_dimensions </div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;    );</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160; </div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;        <span class="keyword">typename</span> sample_type, </div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;        <span class="keyword">typename</span> alloc</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        &gt;</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    std::vector&lt;matrix&lt;typename sample_type::value_type::second_type,0,1&gt; &gt; sparse_to_dense (</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;        <span class="keyword">const</span> std::vector&lt;sample_type, alloc&gt;&amp; samples</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;    );</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160; </div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;        <span class="keyword">typename</span> sample_type, </div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;        <span class="keyword">typename</span> alloc</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;        &gt;</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;    std::vector&lt;matrix&lt;typename sample_type::value_type::second_type,0,1&gt; &gt; sparse_to_dense (</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        <span class="keyword">const</span> std::vector&lt;sample_type, alloc&gt;&amp; samples,</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_dimensions </div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;    );</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160; </div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;        &gt;</div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;    T make_sparse_vector (</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;        <span class="keyword">const</span> T&amp; v</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;    );</div><div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160; </div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;        &gt;</div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;    <span class="keywordtype">void</span> make_sparse_vector_inplace(</div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;        T&amp; vect</div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;    );</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160; </div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;        <span class="keyword">typename</span> EXP, </div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;        <span class="keywordtype">long</span> NR, </div><div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;        <span class="keywordtype">long</span> NC, </div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;        <span class="keyword">typename</span> MM, </div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;        <span class="keyword">typename</span> L</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;        &gt;</div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;    <span class="keywordtype">void</span> sparse_matrix_vector_multiply (</div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;        <span class="keyword">const</span> std::vector&lt;sample_pair&gt;&amp; edges,</div><div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; v,</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;        matrix&lt;T,NR,NC,MM,L&gt;&amp; result</div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;    );</div><div class="line"><a name="l00565"></a><span class="lineno">  565</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160; </div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;        <span class="keyword">typename</span> EXP, </div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;        <span class="keyword">typename</span> T, </div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;        <span class="keywordtype">long</span> NR, </div><div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;        <span class="keywordtype">long</span> NC, </div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;        <span class="keyword">typename</span> MM, </div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;        <span class="keyword">typename</span> L</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;        &gt;</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;    <span class="keywordtype">void</span> sparse_matrix_vector_multiply (</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;        <span class="keyword">const</span> std::vector&lt;ordered_sample_pair&gt;&amp; edges,</div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; v,</div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;        matrix&lt;T,NR,NC,MM,L&gt;&amp; result</div><div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;    );</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00598"></a><span class="lineno">  598</span>&#160; </div><div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00600"></a><span class="lineno">  600</span>&#160;        <span class="keyword">typename</span> EXP</div><div class="line"><a name="l00601"></a><span class="lineno">  601</span>&#160;        &gt;</div><div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160;    matrix&lt;typename EXP::type,0,1&gt; sparse_matrix_vector_multiply (</div><div class="line"><a name="l00603"></a><span class="lineno">  603</span>&#160;        <span class="keyword">const</span> std::vector&lt;sample_pair&gt;&amp; edges,</div><div class="line"><a name="l00604"></a><span class="lineno">  604</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; v</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;    );</div><div class="line"><a name="l00617"></a><span class="lineno">  617</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00618"></a><span class="lineno">  618</span>&#160; </div><div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;        <span class="keyword">typename</span> EXP</div><div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;        &gt;</div><div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;    matrix&lt;typename EXP::type,0,1&gt; sparse_matrix_vector_multiply (</div><div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;        <span class="keyword">const</span> std::vector&lt;ordered_sample_pair&gt;&amp; edges,</div><div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; v</div><div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;    );</div><div class="line"><a name="l00637"></a><span class="lineno">  637</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00638"></a><span class="lineno">  638</span>&#160; </div><div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;        <span class="keyword">typename</span> EXP, </div><div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;        <span class="keyword">typename</span> sparse_vector_type,</div><div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;        <span class="keywordtype">long</span> NR,</div><div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;        <span class="keywordtype">long</span> NC,</div><div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;        <span class="keyword">typename</span> MM,</div><div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;        <span class="keyword">typename</span> L</div><div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;        &gt;</div><div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;    <span class="keywordtype">void</span> sparse_matrix_vector_multiply (</div><div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; m,</div><div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;        <span class="keyword">const</span> sparse_vector_type&amp; v,</div><div class="line"><a name="l00651"></a><span class="lineno">  651</span>&#160;        matrix&lt;T,NR,NC,MM,L&gt;&amp; result</div><div class="line"><a name="l00652"></a><span class="lineno">  652</span>&#160;    );</div><div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160; </div><div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;        <span class="keyword">typename</span> EXP, </div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;        <span class="keyword">typename</span> sparse_vector_type</div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;        &gt;</div><div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;    matrix&lt;typename EXP::type,0,1&gt; sparse_matrix_vector_multiply (</div><div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; m,</div><div class="line"><a name="l00670"></a><span class="lineno">  670</span>&#160;        <span class="keyword">const</span> sparse_vector_type&amp; v</div><div class="line"><a name="l00671"></a><span class="lineno">  671</span>&#160;    );</div><div class="line"><a name="l00681"></a><span class="lineno">  681</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00682"></a><span class="lineno">  682</span>&#160; </div><div class="line"><a name="l00683"></a><span class="lineno">  683</span>&#160;}</div><div class="line"><a name="l00684"></a><span class="lineno">  684</span>&#160; </div><div class="line"><a name="l00685"></a><span class="lineno">  685</span>&#160;<span class="preprocessor">#endif // DLIB_SVm_SPARSE_VECTOR_ABSTRACT_</span></div><div class="line"><a name="l00686"></a><span class="lineno">  686</span>&#160; </div><div class="line"><a name="l00687"></a><span class="lineno">  687</span>&#160; </div><div class="line"><a name="l00688"></a><span class="lineno">  688</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
